import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isNumber, getControl } from 'handie-vue';
import { TextFieldHeadlessWidget } from 'handie-vue/dist/widgets';
import defaultBehaviors from './behavior';
let TextareaEditTextFieldWidget = class TextareaEditTextFieldWidget extends TextFieldHeadlessWidget {
    created() {
        this.setBehaviors('field.textarea', defaultBehaviors);
    }
    render(h) {
        let showWordLimit = this.config.showWordLimit;
        if (showWordLimit === undefined) {
            showWordLimit = this.getBehavior('showWordLimit');
        }
        const props = {
            value: this.value,
            placeholder: this.getPlaceholder(),
            rows: this.config.rows || this.getBehavior('rows'),
            resize: 'none',
        };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.field;
            if (isNumber(min)) {
                props.minLength = min;
            }
            if (isNumber(max)) {
                props.maxLength = max;
                props.wordage = showWordLimit;
            }
        }
        return h(getControl('TextArea'), { props, on: { input: this.onChange } });
    }
};
TextareaEditTextFieldWidget = __decorate([
    Component
], TextareaEditTextFieldWidget);
export default TextareaEditTextFieldWidget;
