import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { getControl, createNode } from 'handie-vue';
import { EnumFilterHeadlessWidget } from 'handie-vue/dist/widgets';
let SelectEditEnumFilterWidget = class SelectEditEnumFilterWidget extends EnumFilterHeadlessWidget {
    render(h) {
        const children = this.options.map(opt => createNode(h, 'Option', { props: { label: opt.label, value: opt.value } }));
        const showEmptyValueOption = this.getCommonBehavior('filter.showEmptyValueOption', false);
        if (showEmptyValueOption) {
            children.unshift(createNode(h, 'Option', {
                props: { label: this.getCommonBehavior('filter.emptyValueOptionLabel'), value: '' },
            }));
        }
        return h(getControl('Select'), {
            props: {
                value: this.internalValue,
                placeholder: this.getPlaceholder(),
                clearable: !showEmptyValueOption,
            },
            on: {
                change: value => this.onChange(value == null ? '' : value),
            },
        }, children);
    }
};
SelectEditEnumFilterWidget = __decorate([
    Component
], SelectEditEnumFilterWidget);
export default SelectEditEnumFilterWidget;
