import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isBoolean, getControl, createNode } from 'handie-vue';
import { RelationFilterHeadlessWidget } from 'handie-vue/dist/widgets';
let SelectEditM2mFilterWidget = class SelectEditM2mFilterWidget extends RelationFilterHeadlessWidget {
    constructor() {
        super(...arguments);
        this.options = [];
    }
    render(h) {
        const children = this.options.map(opt => createNode(h, 'Option', {
            props: { label: opt[this.labelKey], value: opt[this.valueKey] },
        }));
        const showEmptyValueOption = this.getCommonBehavior('filter.showEmptyValueOption', false);
        const multiple = isBoolean(this.config.multiple) ? this.config.multiple : true;
        if (showEmptyValueOption) {
            children.unshift(createNode(h, 'Option', {
                props: {
                    label: this.getCommonBehavior('filter.emptyValueOptionLabel'),
                    value: multiple ? [] : '',
                },
            }));
        }
        return h(getControl('Select'), {
            props: {
                value: this.internalValue,
                placeholder: this.getPlaceholder(),
                multiple,
                clearable: !showEmptyValueOption,
            },
            on: {
                change: value => {
                    if (value == null) {
                        this.onChange((multiple ? [] : ''));
                    }
                    else {
                        this.onChange(value);
                    }
                },
            },
        }, children);
    }
    created() {
        this.fetchRelatedList({}, data => (this.options = data));
    }
};
SelectEditM2mFilterWidget = __decorate([
    Component
], SelectEditM2mFilterWidget);
export default SelectEditM2mFilterWidget;
